#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.8.1
 Author:         myName

 Script Function:
	Template AutoIt script.

#ce ----------------------------------------------------------------------------

; Script Start - Add your code below here

Func _new_iTunes()
	Local $oiTunes = _AutoItObject_Create()
	_AutoItObject_AddProperty($oiTunes, 'mainObject')
	_AutoItObject_AddProperty($oiTunes, 'libPlaylist')
	_AutoItObject_AddProperty($oiTunes, 'libTracks')
	_AutoItObject_AddProperty($oiTunes, 'selTrack')
	_AutoItObject_AddProperty($oiTunes, 'curTrack')
	_AutoItObject_AddProperty($oiTunes, 'playerState')
	_AutoItObject_AddProperty($oiTunes, 'playlistHandle')

	_AutoItObject_AddMethod($oiTunes, 'start', '_iTunes_Start')
	_AutoItObject_AddMethod($oiTunes, 'curGetInfo', '_iTunes_curGetInfo')
	_AutoItObject_AddMethod($oiTunes, 'curGetLyrics', '_iTunes_curGetLyrics')
	_AutoItObject_AddMethod($oiTunes, 'curCoverGet', '_iTunes_curCoverGet')
	_AutoItObject_AddMethod($oiTunes, 'next', '_iTunes_next')
	_AutoItObject_AddMethod($oiTunes, 'prev', '_iTunes_prev')

	Return $oiTunes
EndFunc

Func _iTunes_next($oSelf)
	$oSelf.mainObject.NextTrack
EndFunc

Func _iTunes_prev($oSelf)
	$oSelf.mainObject.PreviousTrack
EndFunc

Func _iTunes_curCoverGet($oSelf, $sPath)
	Return $oSelf.mainObject.CurrentTrack.Artwork(1).SaveArtworkToFile($sPath)
EndFunc

Func _iTunes_curGetLyrics($oSelf)
	Return $oSelf.mainObject.CurrentTrack.Lyrics
EndFunc

Func _iTunes_start($oSelf)
	$oSelf.mainObject = ObjCreate("iTunes.Application")
EndFunc

Func _iTunes_curGetInfo($oSelf)
	Local $aInfo[23]
	$aInfo[0] = $oSelf.mainObject.CurrentTrack.Album
	$aInfo[1] = $oSelf.mainObject.CurrentTrack.Artist
	$aInfo[2] = $oSelf.mainObject.CurrentTrack.Name
	$aInfo[3] = $oSelf.mainObject.CurrentTrack.Comment
	$aInfo[4] = $oSelf.mainObject.CurrentTrack.Compilation
	$aInfo[5] = $oSelf.mainObject.CurrentTrack.Composer
	$aInfo[6] = $oSelf.mainObject.CurrentTrack.DateAdded
	$aInfo[7] = $oSelf.mainObject.CurrentTrack.Duration
	$aInfo[8] = $oSelf.mainObject.CurrentTrack.EQ
	$aInfo[9] = $oSelf.mainObject.CurrentTrack.Genre
	$aInfo[10] = $oSelf.mainObject.CurrentTrack.KindAsString
	$aInfo[11] = $oSelf.mainObject.CurrentTrack.Location
	$aInfo[12] = $oSelf.mainObject.CurrentTrack.ModificationDate
	$aInfo[13] = $oSelf.mainObject.CurrentTrack.PlayedCount
	$aInfo[14] = $oSelf.mainObject.CurrentTrack.PlayedDate
	$aInfo[15] = $oSelf.mainObject.CurrentTrack.Playlist
	$aInfo[16] = $oSelf.mainObject.CurrentTrack.Rating
	$aInfo[17] = $oSelf.mainObject.CurrentTrack.SampleRate
	$aInfo[18] = $oSelf.mainObject.CurrentTrack.Size
	$aInfo[19] = $oSelf.mainObject.CurrentTrack.Time
	$aInfo[20] = $oSelf.mainObject.CurrentTrack.Tracknumber
	$aInfo[21] = $oSelf.mainObject.CurrentTrack.VolumeAdjustment
	$aInfo[22] = $oSelf.mainObject.CurrentTrack.Year
	Return $aInfo
EndFunc























